import java.io.*;

class FontSettings implements Serializable {
	// The access modifier does not affects the serialization
	public int fontSize;
	protected String fontFamily;
	private boolean isBold;
	
	// A no-arg constructor is not needed until this class is not a
	// non-serializable parent of a serializable class, or until this
	// class implements the java.io.Externalizable interface.
	FontSettings(String family) {
		fontFamily = family;
	}
	
	public String getFontFamily() {
		return fontFamily;
	}
	
	// The getters and setters are not invoked by the serialization
	public boolean isBold() {
		System.out.println("FontSettings.isBold() invoked");
		return isBold;
	}
	
	public void setBold(boolean b) {
		System.out.println("FontSettings.setBold() invoked");
		isBold = b;
	}
	
	@Override
	public String toString() {
		return "FontSettings { fontSize = " + fontSize
			+ ", fontFamily = " + fontFamily
			+ ", isBold = " + isBold + " }";
	}
}
