package eak.rmi.api;

import java.rmi.Remote;
import java.rmi.RemoteException;

// All remotely accessable interface must extend the Remote interface.
// Every method must declared as it throws a RemoteException.
public interface CalculatorService extends Remote {

    // Identifier for registry binding.
    static final String NAME = "CalculatorService";

    // A simple operation to add two integer numbers.
    int add(int a, int b) throws RemoteException;

    // A second operation which computes the square root of a number.
    double sqrt(double a) throws RemoteException;
}
