package eak.rmi.client;

import eak.rmi.api.CalculatorService;
import java.rmi.NotBoundException;
import java.rmi.RemoteException;
import java.rmi.registry.LocateRegistry;
import java.rmi.registry.Registry;
import java.util.logging.Level;
import java.util.logging.Logger;

public class ClientMain {

    public static void main(String[] args) {
        // Set up a security manager to allow remote code loading
        if(null == System.getSecurityManager()) {
            System.setSecurityManager(new SecurityManager());
        }

        try {
            // Locate the RMI registry
            Registry registry = LocateRegistry.getRegistry();

            // Get a client stub for the service
            CalculatorService service
                = (CalculatorService)registry.lookup(CalculatorService.NAME);

            // Invoke the remote methods and show the results
            System.err.println(service.add(3, 5));
            System.err.println(service.sqrt(2.67));
        } catch (RemoteException | NotBoundException ex) {
            Logger.getLogger(ClientMain.class.getName()).log(Level.SEVERE, null, ex);
        }
    }

}
