
import java.io.IOException;
import java.io.InputStream;
import java.io.ObjectInputStream;
import java.io.ObjectOutputStream;
import java.io.OutputStream;
import java.net.Socket;
import java.net.UnknownHostException;
import java.util.logging.Level;
import java.util.logging.Logger;

public class ClientMain {

    private static final String HOST = "localhost";
    private static final int PORT = 1234;

    public static void main(String[] args) {
        Socket s = null;

        try {
            // Open connection to the server
            s = new Socket(HOST, PORT);

            // Create request
            String request = "This is a test message.";

            // Send request
            OutputStream os = s.getOutputStream();
            ObjectOutputStream oos = new ObjectOutputStream(os);
            oos.writeObject(request);
            oos.flush(); // important: immediately write contents to the socket

            // Receive response
            InputStream is = s.getInputStream();
            ObjectInputStream ois = new ObjectInputStream(is);
            String response = (String)ois.readObject();

            // Process response
            System.out.println("Response: " + response);
        } catch (UnknownHostException ex) {
            Logger.getLogger(ClientMain.class.getName()).log(Level.SEVERE, null, ex);
        } catch (IOException | ClassNotFoundException ex) {
            Logger.getLogger(ClientMain.class.getName()).log(Level.SEVERE, null, ex);
        } finally {
            // Close connection to the server
            if(s != null) {
                try {
                    s.close();
                } catch (IOException ex) {
                    Logger.getLogger(ClientMain.class.getName()).log(Level.SEVERE, null, ex);
                }
            }
        }
    }
}
