package eak.jdbc_rmi.client;

import java.net.MalformedURLException;
import java.rmi.Naming;
import java.rmi.NotBoundException;
import java.rmi.RemoteException;
import java.util.logging.Level;
import java.util.logging.Logger;
import eak.jdbc_rmi.api.*;

public class ClientMain {

    public static void main(String[] args) {
        // Set up a security manager to allow remote code loading
        if(null == System.getSecurityManager()) {
            System.setSecurityManager(new SecurityManager());
        }

        try {
            // Get a client stub for the service
            LoginService service
                = (LoginService)Naming.lookup("//localhost:1066/" + LoginService.NAME);

            do {
                // Get input from the console
                System.out.println("Please log in!");
                System.out.print("User name: ");
                String userName = System.console().readLine();
                System.out.print("Password: ");
                String password = System.console().readLine();

                LoginResult result = service.login(userName, password);

                // Process outcome and maybe loop back to prompt
                switch(result.getOutcome()) {
                    case SUCCESSFUL:
                        System.out.println(result.getMessage());
                        return;
                    
                    case INVALID_CREDENTIALS:
                    case INTERNAL_ERROR:
                        System.out.println(result.getMessage());
                }
            } while(true);
        } catch (RemoteException | NotBoundException | MalformedURLException ex) {
            Logger.getLogger(ClientMain.class.getName()).log(Level.SEVERE, null, ex);
        }
    }

}
