package eak.jdbc_rmi.server;

import java.rmi.Remote;
import java.rmi.RemoteException;
import java.rmi.registry.LocateRegistry;
import java.rmi.registry.Registry;
import java.rmi.server.UnicastRemoteObject;
import java.util.logging.Level;
import java.util.logging.Logger;
import eak.jdbc_rmi.api.LoginService;

public class ServerMain {

    public static void main(String[] args) {
        // Set up a security manager to allow remote code loading
        if(null == System.getSecurityManager()) {
            System.setSecurityManager(new SecurityManager());
        }

        try {
            // Instantiate the service implementation
            LoginServiceImpl service = new LoginServiceImpl();

            // Export it on a random port (start to listen to clients)
            Remote stub = UnicastRemoteObject.exportObject(service, 0);

            // Create a new RMI registry on port 1066
            Registry registry = LocateRegistry.createRegistry(1066);

            // Make the service available through a fixed name
            registry.rebind(LoginService.NAME, stub);

            // Indicate that the server started successfully
            System.err.println("Server started ...");
        } catch (RemoteException ex) {
            Logger.getLogger(ServerMain.class.getName()).log(Level.SEVERE, null, ex);
        }
    }
}
