SQL injection attack
====================

Demonstration of a well-konwn vulnerability in database queries, called
SQL injection. The main idea is that the user can inject custom SQL commands
into the original application logic. For more information, see:

https://en.wikipedia.org/wiki/SQL_injection


Compiling and running the examples
----------------------------------

Run the make_and_run.sh script. To clean the build run clean.sh.
The $JAVA_HOME environment variable must be set to the directory
of the Java SDK!


Usage
-----

The application simulates a simple login interface, where the user can provide
its user name and password. Every user have a value called `level`, which
symbolizes the permissions connected to the account. When the level is higher,
the user has more privileges. The task is to bypass the login system, and
achieve as high user level as possible, without knowing a user name or password.


Solutions
---------

To try them out, write the given string into the user name field, and leave the
password empty.

1. Login with unspecified level and user name:

     ' or true -- 

2. Login with the name of the user who has highest level:

     ' or true order by level desc -- 

3. Login with a specified user name and level:

     ' or false union values ('Superman', 9999) -- 


Protection
----------

The protection against SQL injection is simple: use prepared statements to pass
parameters to SQL queries. To change the given implementation to a secure one,
just set `USE_VULNERABLE_IMPLEMENTATION` variable to false in `Main.java`.

