JPA annotations and simple queries
==================================

JPA has a lot of annotations to control how entities and their fields should be
persisted. This example shows the usage a bunch of these:

- @Entity, @Id, @GeneratedValue
- @Table, @Column
- @Temporal, @Enumerated
- @Transient (and its relation to the transient keyword)
- @NamedQuery

It also shows the practice that entity classes should override their equivalence
relation to consider different objects as the same entity if their primary key
fields have the same value.


Compiling and running the examples
----------------------------------

Run the make_and_run.sh script. To clean the build run clean.sh.
The $JAVA_HOME environment variable must be set to the directory
of the Java SDK. The variable $ECLIPSELINK_HOME also must be set to
the directory where the following eclipselink archives can be found:

eclipselink.jar
javax.persistence_2.1*.jar
org.eclipse.persistence.jpa.jpql_2.5*.jar

This path is usually can be found as follows:
<netbeans-ide-directory>/java/modules/ext/eclipselink
