import javax.ejb.EJB;

import eak.Calculator;
import eak.ValueHolder;


//Running in an application client container:
// <glassfish-top-dir>/glassfish/bin/appclient -jar calculator-client-di.jar

// !!! Important: the calculator-interface.jar must be in the same directory as the client!
public class Main {
	
	// Get a reference to the bean by dependency injection provided by
	// the application client container. The mappedName is a vendor-specific
	// (non-portable) name of the component.
	@EJB(mappedName="calc")
	// A portable name can also be used here:
	// @EJB(lookup="java:global/calculator-application/calculator-ejb/calcBean!eak.Calculator")
	private static Calculator calculator;
	
	public static void main(String[] args) {
		// Call bean methods
		ValueHolder result;
		
		result = calculator.add(new ValueHolder(41), new ValueHolder(1));
		System.out.println("The sum of 41 and 1 is " + result.value);
		
		// Changing the value in the result will not have any effect in the
		// server, because it is passed by-copy.
		result.value = 2;
		
		// It is not sure this method will be called on the same
		// bean instance in the server as the previous.
		result = calculator.sqrt(result);
		System.out.println("The square root of 2 is " + result.value);
	}
}
