package eak;

import javax.naming.Context;
import javax.naming.InitialContext;
import javax.naming.NamingException;

public class Main {

	public static void main(String[] args) throws NamingException {
		// Lookup the beans with JNDI from this standalone client.
		// (The handling of NamingExceptions is omitted for this example.)
		// The initial context setup is done by the gf-client.jar,
		// which is added to the project's build path.
		Context ctx = new InitialContext();
		StatefulCalculator calculator = (StatefulCalculator) ctx
				.lookup("java:global/calculator-app/calculator-ejb/CalculatorBean!eak.StatefulCalculator");
		ResultStorage storage = (ResultStorage) ctx
				.lookup("java:global/calculator-app/calculator-ejb/ResultStorageBean!eak.ResultStorage");
		ctx.close();

		// Testing the exception of the sqrt method
		calculator.sub(1);
		try {
			calculator.sqrt();
		} catch (CalculatorException e) {
			System.out.println("Calculation error: " + e.getMessage());
		}

		// Do some calculations
		calculator.add(43);
		// ...

		// The instance will be removed after this call!
		int result = calculator.getResult();

		System.out.println("Total: " + result);

		// It throws an exception, because the bean instance is removed!
		// calculator.add(0);

		// Print the collected results
		System.out.println("Results so far:");
		for (Result r : storage.getAllResults()) {
			System.out.println(r.getResult() + " @ " + r.getWhen().toString());
		}
	}

}
