package eak;

import java.util.Date;
import java.util.List;

import javax.ejb.Remote;
import javax.ejb.Stateless;
import javax.persistence.EntityManager;
import javax.persistence.PersistenceContext;

@Stateless
@Remote(ResultStorage.class)
public class ResultStorageBean implements ResultStorage, ResultPersistence {

	// Inject a persistence context. Because there is only one persistence unit
	// is defined in the presistence.xml, the unitName property can be omitted.
	@PersistenceContext
	private EntityManager em;

	@Override
	public void persistWithTimestamp(int result) {
		Result r = new Result(new Date(), result);
		em.persist(r);
	}

	public List<Result> getAllResults() {
		return em.createQuery("SELECT r FROM Result r", Result.class)
				.getResultList();
	}

}
