package eak;

import java.io.Serializable;
import java.util.Date;

import javax.persistence.Entity;
import javax.persistence.Id;
import javax.persistence.Temporal;
import javax.persistence.TemporalType;

// Designed to store the time and result of a previous calculation.
@Entity
public class Result implements Serializable {

	private static final long serialVersionUID = 1L;
	
	@Id
	@Temporal(TemporalType.TIMESTAMP)
	private Date when;
	
	private int result;
	
	public Result() {
		// A parameterless constructor needed!
	}
	
	public Result(Date when, int result) {
		this.when = when;
		this.result = result;
	}
	
	public Date getWhen() {
		return when;
	}

	public void setWhen(Date when) {
		this.when = when;
	}

	public int getResult() {
		return result;
	}

	public void setResult(int result) {
		this.result = result;
	}

	@Override
	public int hashCode() {
		final int prime = 31;
		int result = 1;
		result = prime * result + ((when == null) ? 0 : when.hashCode());
		return result;
	}

	@Override
	public boolean equals(Object obj) {
		if (this == obj) {
			return true;
		}
		if (obj == null) {
			return false;
		}
		if (!(obj instanceof Result)) {
			return false;
		}
		Result other = (Result) obj;
		if (when == null) {
			if (other.when != null) {
				return false;
			}
		} else if (!when.equals(other.when)) {
			return false;
		}
		return true;
	}

}
