Stateful session bean with JPA
==============================

This example demonstrates the usage of stateful session beans,
and also illustrates how to persist entities with JPA from an EJB.
The application contains interceptor classes to log method calls, and change
the return value of some business calls.


Compiling and running the examples
----------------------------------

Import the projects into an Eclipse (version >= 4.3 Kepler), which is configured
to use a GlassFish application server (version >= 4), then deploy the
`calculator-app` project on the server as usual. The application uses the
default database connection named `jdbc/__default`. To use this connection, the
database needs to be started with the following command, before the deployment:

<glassfish-install-dir>/bin/asadmin start-database

The import order of the projects should be:

1. calculator-if
2. calculator-ejb
3. calculator-cl
4. calculator-app

Depending on the installation path of GlassFish, the settings of `calculator-cl`
project may need to be updated. It references the `gf-client.jar` under the
`Java Build Path / Libraries` tab. Please check and update the reference if
needed. The `gf-client.jar` can be found under the following path:

<glassfish-install-dir>/glassfish/lib/gf-client.jar

You can run the Main class from `calculator-cl` as a usual java application.

